"""
    Sample metadata API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: 5.7.0
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from sample_metadata.api_client import ApiClient, Endpoint as _Endpoint
from sample_metadata.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types,
    async_wrap
)
from sample_metadata.model.http_validation_error import HTTPValidationError
from sample_metadata.model.project_summary_response import ProjectSummaryResponse
from sample_metadata.model.search_item import SearchItem
from sample_metadata.model.search_response_model import SearchResponseModel
from sample_metadata.model.sequence_type import SequenceType


class WebApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        self.get_project_summary_async = async_wrap(self.get_project_summary)
        self.get_project_summary_endpoint = _Endpoint(
            settings={
                'response_type': (ProjectSummaryResponse,),
                'auth': [
                    'HTTPBearer'
                ],
                'endpoint_path': '/api/v1/web/{project}/summary',
                'operation_id': 'get_project_summary',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'project',
                    'search_item',
                    'limit',
                    'token',
                ],
                'required': [
                    'project',
                    'search_item',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'project':
                        (str,),
                    'search_item':
                        ([SearchItem],),
                    'limit':
                        (int,),
                    'token':
                        (int,),
                },
                'attribute_map': {
                    'project': 'project',
                    'limit': 'limit',
                    'token': 'token',
                },
                'location_map': {
                    'project': 'path',
                    'search_item': 'body',
                    'limit': 'query',
                    'token': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

        self.search_by_keyword_async = async_wrap(self.search_by_keyword)
        self.search_by_keyword_endpoint = _Endpoint(
            settings={
                'response_type': (SearchResponseModel,),
                'auth': [
                    'HTTPBearer'
                ],
                'endpoint_path': '/api/v1/web/search',
                'operation_id': 'search_by_keyword',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'keyword',
                ],
                'required': [
                    'keyword',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'keyword':
                        (str,),
                },
                'attribute_map': {
                    'keyword': 'keyword',
                },
                'location_map': {
                    'keyword': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

        self.sync_seqr_project_async = async_wrap(self.sync_seqr_project)
        self.sync_seqr_project_endpoint = _Endpoint(
            settings={
                'response_type': (bool, date, datetime, dict, float, int, list, str, none_type,),
                'auth': [
                    'HTTPBearer'
                ],
                'endpoint_path': '/api/v1/web/{project}/{sequence_type}/sync-dataset',
                'operation_id': 'sync_seqr_project',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'sequence_type',
                    'project',
                    'sync_families',
                    'sync_individual_metadata',
                    'sync_individuals',
                    'sync_es_index',
                    'sync_saved_variants',
                    'sync_cram_map',
                    'post_slack_notification',
                ],
                'required': [
                    'sequence_type',
                    'project',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'sequence_type':
                        (SequenceType,),
                    'project':
                        (str,),
                    'sync_families':
                        (bool,),
                    'sync_individual_metadata':
                        (bool,),
                    'sync_individuals':
                        (bool,),
                    'sync_es_index':
                        (bool,),
                    'sync_saved_variants':
                        (bool,),
                    'sync_cram_map':
                        (bool,),
                    'post_slack_notification':
                        (bool,),
                },
                'attribute_map': {
                    'sequence_type': 'sequence_type',
                    'project': 'project',
                    'sync_families': 'sync_families',
                    'sync_individual_metadata': 'sync_individual_metadata',
                    'sync_individuals': 'sync_individuals',
                    'sync_es_index': 'sync_es_index',
                    'sync_saved_variants': 'sync_saved_variants',
                    'sync_cram_map': 'sync_cram_map',
                    'post_slack_notification': 'post_slack_notification',
                },
                'location_map': {
                    'sequence_type': 'path',
                    'project': 'path',
                    'sync_families': 'query',
                    'sync_individual_metadata': 'query',
                    'sync_individuals': 'query',
                    'sync_es_index': 'query',
                    'sync_saved_variants': 'query',
                    'sync_cram_map': 'query',
                    'post_slack_notification': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )

    def get_project_summary(
        self,
        project,
        search_item,
        **kwargs
    ):
        """Get Project Summary  # noqa: E501

        Creates a new sample, and returns the internal sample ID  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_project_summary(project, search_item, async_req=True)
        >>> result = thread.get()

        Args:
            project (str):
            search_item ([SearchItem]):

        Keyword Args:
            limit (int): [optional] if omitted the server will use the default value of 20
            token (int): [optional] if omitted the server will use the default value of 0
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            ProjectSummaryResponse
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['project'] = \
            project
        kwargs['search_item'] = \
            search_item
        return self.get_project_summary_endpoint.call_with_http_info(**kwargs)

    def search_by_keyword(
        self,
        keyword,
        **kwargs
    ):
        """Search By Keyword  # noqa: E501

        This searches the keyword, in families, participants + samples in the projects that you are a part of (automatically).  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.search_by_keyword(keyword, async_req=True)
        >>> result = thread.get()

        Args:
            keyword (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            SearchResponseModel
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['keyword'] = \
            keyword
        return self.search_by_keyword_endpoint.call_with_http_info(**kwargs)

    def sync_seqr_project(
        self,
        sequence_type,
        project,
        **kwargs
    ):
        """Sync Seqr Project  # noqa: E501

        Sync a metamist project with its seqr project (for a specific sequence type)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.sync_seqr_project(sequence_type, project, async_req=True)
        >>> result = thread.get()

        Args:
            sequence_type (SequenceType):
            project (str):

        Keyword Args:
            sync_families (bool): [optional] if omitted the server will use the default value of True
            sync_individual_metadata (bool): [optional] if omitted the server will use the default value of True
            sync_individuals (bool): [optional] if omitted the server will use the default value of True
            sync_es_index (bool): [optional] if omitted the server will use the default value of True
            sync_saved_variants (bool): [optional] if omitted the server will use the default value of True
            sync_cram_map (bool): [optional] if omitted the server will use the default value of True
            post_slack_notification (bool): [optional] if omitted the server will use the default value of True
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            bool, date, datetime, dict, float, int, list, str, none_type
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['sequence_type'] = \
            sequence_type
        kwargs['project'] = \
            project
        return self.sync_seqr_project_endpoint.call_with_http_info(**kwargs)

